﻿'***************************************************************************************************
'   配属一覧サンプル②(更新登録画面)                           dlgGetMdbDataTest02(Form)
'
'   作成者:井上治  URL:https://www.ne.jp/asahi/excel/inoue/ [Excelでお仕事!]
'***************************************************************************************************
' 変更日付 Rev     変更履歴内容-------------------------------------------------------------------->
' 17/01/22(1.0.1.0)新規作成
' 17/01/29(1.0.2.0)ダブルクリック抑制、未更新終了チェック関連の共通クラス化対応
'***************************************************************************************************
Friend Class dlgGetMdbDataTest02
    '===============================================================================================
    Private Const g_cnsTitle As String = "配属一覧サンプル②"
    '-----------------------------------------------------------------------------------------------
    Private g_objAboutMDB As clsAboutMDB2                   ' データベースI/Oクラス(MDB用)
    Private g_objCheckNotUpdate As clsCheckNotUpdate2       ' 未更新終了チェック関連クラス
    Private g_objOmitDoubleClick As clsOmitDoubleClick2     ' ダブルクリック抑制クラス
    '-----------------------------------------------------------------------------------------------
    ' 一覧フォームとの受け渡し項目
    Private g_strSQL_Base As String                         ' 抽出SQL文共通部
    Private g_strScd As String                              ' 社員コード
    Private g_dteKaishiYmd As Date                          ' 配属開始日
    ' 処理モードは今回のサンプルは「2=変更」のみ
    Private g_intUpdateMode As Integer = 2                  ' 処理モード(0=参照,1=新規,2=変更)
    Private g_intUpdateResult As Integer = 0                ' 更新結果(0=無,1=追加,2=更新,9=削除)
    '-----------------------------------------------------------------------------------------------
    ' コンボボックスに対応したコードテーブル
    Private g_tblBusyoCd() As String                        ' 部署コードテーブル
    Private g_tblYakuCd() As String                         ' 役職コードテーブル

    '***********************************************************************************************
    ' ■■■ 初期化 ■■■
    '***********************************************************************************************
    '* 処理名　：New
    '* 機能　　：初期化
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = データベースI/Oクラス(Object)
    '* 　　　　　Arg2 = 抽出SQL文共通部(String)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Friend Sub New(ByRef objAboutMDB As clsAboutMDB2, ByVal strSQL_Base As String)
        '-------------------------------------------------------------------------------------------
        ' ※Windowsフォームデザイナ初期化(必須)
        Call InitializeComponent()
        ' フォームデザイナモード時は以下をスキップする
        If Me.DesignMode Then Exit Sub
        '-------------------------------------------------------------------------------------------
        g_objAboutMDB = objAboutMDB                         ' データベースI/Oクラス(MDB用)
        g_strSQL_Base = strSQL_Base                         ' 抽出SQL文共通部
        '-------------------------------------------------------------------------------------------
        ' 未更新終了チェック関連クラスの初期化
        g_objCheckNotUpdate = New clsCheckNotUpdate2(Me)
    End Sub

    '***********************************************************************************************
    ' ■■■ フォームイベント ■■■
    '***********************************************************************************************
    '* 処理名　：Form_Load
    '* 機能　　：フォームイベント(Load)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub Form_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        '-------------------------------------------------------------------------------------------
        ' 一旦、登録ボタン等を消去
        BTN_OK.Enabled = False
        '-------------------------------------------------------------------------------------------
        ' ダブルクリック抑制クラスの初期化
        g_objOmitDoubleClick = New clsOmitDoubleClick2(Me)
    End Sub

    '***********************************************************************************************
    '* 処理名　：Form_Shown
    '* 機能　　：フォーム初期表示(Shown)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub Form_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        '-------------------------------------------------------------------------------------------
        g_intUpdateResult = 0
        '-------------------------------------------------------------------------------------------
        ' フォーム位置の保持
        If Me.StartPosition <> FormStartPosition.Manual Then
            Me.StartPosition = FormStartPosition.Manual
        End If
        '-------------------------------------------------------------------------------------------
        ' 初回起動時は初期セットアップを行なう
        If g_objOmitDoubleClick.FirstShown Then
            ' コンボリスト等の初期セットアップ
            If Not FP_SetFormList() Then
                g_objCheckNotUpdate.FatalError = True
                Me.Close()
                Exit Sub
            End If
            g_objOmitDoubleClick.FirstShown = False
        End If
        '-------------------------------------------------------------------------------------------
        ' 指定社員情報の表示
        If Not FP_ShowSyainInfo() Then
            g_objCheckNotUpdate.FatalError = True
            Me.Close()
            Exit Sub
        End If
        '-------------------------------------------------------------------------------------------
        ' 未登録終了警告スイッチをクリア
        g_objCheckNotUpdate.NotUpdate = False
        g_objOmitDoubleClick.Shown = True
    End Sub

    '***********************************************************************************************
    ' ■■■ コントロールイベント ■■■
    '***********************************************************************************************
    '* 処理名　：BTN_CANCEL_Click
    '* 機能　　：「キャンセル」ボタンイベント(Click)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub BTN_CANCEL_Click(ByVal sender As Object, _
                                 ByVal e As System.EventArgs) Handles BTN_CANCEL.Click
        '-------------------------------------------------------------------------------------------
        ' ダブルクリック等の多重操作を抑制
        If g_objOmitDoubleClick.CheckDoubleClick(True) Then Exit Sub
        '-------------------------------------------------------------------------------------------
        ' フォームを閉じる
        Me.Close()
    End Sub

    '***********************************************************************************************
    '* 処理名　：BTN_OK_Click
    '* 機能　　：「登録」ボタンイベント(Click)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub BTN_OK_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles BTN_OK.Click
        '-------------------------------------------------------------------------------------------
        ' ダブルクリック等の多重操作を抑制
        If g_objOmitDoubleClick.CheckDoubleClick() Then Exit Sub
        '-------------------------------------------------------------------------------------------
        Me.Activate()
        BTN_OK.Focus()
        ' ｢登録｣ボタン処理
        Call GP_OK_Click()
    End Sub

    '***********************************************************************************************
    '* 処理名　：CBO_BUSYO_SelectedIndexChanged
    '* 機能　　：「部署」コンボイベント(SelectedIndexChanged)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub CBO_BUSYO_SelectedIndexChanged(ByVal sender As Object, _
                                               ByVal e As System.EventArgs) _
                                               Handles CBO_BUSYO.SelectedIndexChanged
        '-------------------------------------------------------------------------------------------
        ' ダブルクリック等の多重操作を抑制
        If g_objOmitDoubleClick.CheckDoubleClick() Then Exit Sub
        '-------------------------------------------------------------------------------------------
        '' 未登録終了警告スイッチをセット
        'g_objCheckNotUpdate.NotUpdate = True
        ' ｢登録｣ボタン有効化
        BTN_OK.Enabled = True
    End Sub

    '***********************************************************************************************
    '* 処理名　：CBO_YAKU_SelectedIndexChanged
    '* 機能　　：「役職」コンボイベント(SelectedIndexChanged)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(デフォルト)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub CBO_YAKU_SelectedIndexChanged(ByVal sender As Object, _
                                              ByVal e As System.EventArgs) _
                                              Handles CBO_YAKU.SelectedIndexChanged
        '-------------------------------------------------------------------------------------------
        ' ダブルクリック等の多重操作を抑制
        If g_objOmitDoubleClick.CheckDoubleClick() Then Exit Sub
        '-------------------------------------------------------------------------------------------
        '' 未登録終了警告スイッチをセット
        'g_objCheckNotUpdate.NotUpdate = True
        ' ｢登録｣ボタン有効化
        BTN_OK.Enabled = True
    End Sub

    '***********************************************************************************************
    ' ■■■ サブ処理(登録更新系) ■■■
    '***********************************************************************************************
    '* 処理名　：GP_OK_Click
    '* 機能　　：｢登録｣ボタン処理
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月29日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Sub GP_OK_Click()
        '-------------------------------------------------------------------------------------------
        If Not g_objCheckNotUpdate.NotUpdate Then
            MessageBox.Show(Me, _
                            "何も変更されていません。", _
                            g_cnsTitle, _
                            MessageBoxButtons.OK, _
                            MessageBoxIcon.Information)
            Exit Sub
        ElseIf Not FP_CheckForm() Then          ' 登録チェック
            Exit Sub
        End If
        '-------------------------------------------------------------------------------------------
        ' 登録確認メッセージ
        If MessageBox.Show( _
            Me, _
            "表示されている内容を登録します。" & _
            ControlChars.CrLf & ControlChars.CrLf & "よろしいですね？", _
            g_cnsTitle, _
            MessageBoxButtons.YesNo, _
            MessageBoxIcon.Information) <> DialogResult.Yes Then Exit Sub
        ' 処理中判定スイッチ対応
        g_objOmitDoubleClick.OmitDoubleClick = True
        '-------------------------------------------------------------------------------------------
        ' 登録(更新)処理
        If FP_UpdateTables() Then
            ' 処理結果を返す⇒今回のサンプルは「2=変更」のみ
            g_intUpdateResult = g_intUpdateMode
            ' 未登録終了警告スイッチをクリア
            g_objCheckNotUpdate.NotUpdate = False
            Me.Close()
        End If
    End Sub

    '***********************************************************************************************
    '* 処理名　：FP_CheckForm
    '* 機能　　：登録チェック
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：チェック成否(Boolean)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_CheckForm() As Boolean
        '-------------------------------------------------------------------------------------------
        Dim strMSG As String = String.Empty                     ' エラーメッセージ
        ' 部署未選択
        If CBO_BUSYO.SelectedIndex < 0 Then
            Call GP_AppendMessage(strMSG, "「部署」が選択されていません。")
        End If
        ' 役職未選択
        If CBO_YAKU.SelectedIndex < 0 Then
            Call GP_AppendMessage(strMSG, "「役職」が選択されていません。")
        End If
        '-------------------------------------------------------------------------------------------
        ' チェック結果
        If strMSG.Length <> 0 Then
            MessageBox.Show(Me, _
                            strMSG, _
                            g_cnsTitle, _
                            MessageBoxButtons.OK, _
                            MessageBoxIcon.Exclamation)
            Return False
        Else
            Return True
        End If
    End Function

    '***********************************************************************************************
    '* 処理名　：FP_UpdateTables
    '* 機能　　：登録(更新)処理
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理成否(Boolean)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：本処理は単一テーブル､単一レコードのみの更新用として調整(非Transactionモード)
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_UpdateTables() As Boolean
        '-------------------------------------------------------------------------------------------
        Dim blnResult As Boolean = False                            ' 処理結果
        Dim blnSuccess As Boolean = False                           ' 登録成否
        Dim strMsgHeader As String = String.Empty                   ' メッセージヘッダ
        Dim strMSG As String = String.Empty                         ' メッセージ
        Dim strSQL As String = String.Empty                         ' SQL文
        Dim blnUpdate As Boolean = False                            ' 更新有りフラグ
        Dim tblFldO() As Object = Nothing                           ' レコードフィールド
        ' MDB接続
        Using dbCon As OleDb.OleDbConnection = g_objAboutMDB.GetConnection(blnResult)
            ' 接続失敗
            If Not blnResult Then Return False
            '---------------------------------------------------------------------------------------
            ' データベースに接続
            dbCon.Open()
            ' コマンド割り当て
            Using dbCommand As OleDb.OleDbCommand = dbCon.CreateCommand()
                Try
                    strMsgHeader = g_cnsMDBMSG003                       ' 参照失敗
                    Dim strWhere As String = " WHERE [SCD]='" & g_strScd & g_cnsSC ' WHERE句
                    strWhere &= " AND [KAISHI_YMD]=" & FP_SQLDateSUB2(g_dteKaishiYmd) & g_cnsCOL
                    strSQL = g_cnsSELECT_AST & g_cnsMST_HAIZOKU & strWhere
                    ' DataTableにレコードを読み込む
                    Dim dbTbl As DataTable = FP_GetDataTable(dbCommand, strSQL) ' DataTable
                    ' 読込レコードがあるか
                    If dbTbl.Rows.Count <> 0 Then
                        ' 更新可
                        blnUpdate = True
                        ' 最終的な変更前レコード内容の取得
                        tblFldO = dbTbl.Rows(0).ItemArray.Clone
                        ' NULLがあり得る日付項目はNothingに変換
                        Call GP_ReplaceDateFields(tblFldO, New Integer() {1, 2})
                    Else
                        ' 未登録(今回のサンプルは「2=変更」のみ)
                        strMSG = g_cnsMDBMSG012
                    End If
                    ' データテーブルをクリア
                    dbTbl.Clear()
                    dbTbl.Reset()
                    ' 更新可か
                    If blnUpdate Then
                        ' 更新有無判定のためクリア
                        strSQL = String.Empty
                        ' 更新SQL文の編集
                        Call GP_MakeUpdateSql(tblFldO, strWhere, strSQL)
                        ' 更新対象があるか
                        If strSQL.Length <> 0 Then
                            strMsgHeader = g_cnsMDBMSG002
                            ' コマンド発行
                            dbCommand.CommandText = strSQL
                            dbCommand.ExecuteNonQuery()
                            blnSuccess = True
                        Else
                            ' 更新項目無し
                            strMSG = "更新対象項目がありませんでした。"
                        End If
                    End If
                Catch ex As Exception
                    ' 更新SQLエラー処理(致命エラー扱い)
                    Call g_objAboutMDB.ExecuteSQLError(ex.Message, _
                                                       strMsgHeader, _
                                                       g_cnsMST_HAIZOKU, _
                                                       strSQL)
                End Try
            End Using
            ' データベースを切断
            dbCon.Close()
            '---------------------------------------------------------------------------------------
        End Using
        '-------------------------------------------------------------------------------------------
        ' エラーがあるか
        If strMSG.Length <> 0 Then
            ' ここでのエラーには致命エラーは含まれない
            MessageBox.Show(Me, _
                            strMSG, _
                            g_cnsTitle, _
                            MessageBoxButtons.OK, _
                            MessageBoxIcon.Exclamation)
        End If
        Return blnSuccess
    End Function

    '***********************************************************************************************
    '* 処理名　：GP_MakeUpdateSql
    '* 機能　　：更新登録SQL文編集
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：(なし)
    '* 引数　　：Arg1 = 現行テーブル内容(Array:Object)
    '*           Arg2 = WHERE句(String)
    '* 　　　　　Arg3 = 更新SQL文(String)               ※Ref参照
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：本処理(サンプル)では1社員コードに対して1配属情報として更新する
    '***********************************************************************************************
    Private Sub GP_MakeUpdateSql(ByVal tblFldO() As Object, _
                                 ByVal strWhere As String, _
                                 ByRef strUpdSQL As String)
        '-------------------------------------------------------------------------------------------
        ' フォーム上のアイテムから更新用テーブルを作成
        Dim tblFldN() As Object = FP_SetTableFromItems()            ' 新規登録側テーブル
        '-------------------------------------------------------------------------------------------
        ' UPDATE文を編集
        Dim strSQL As String = g_cnsUPDATE & g_cnsMST_HAIZOKU & g_cnsSET ' SQL文
        Dim intIx As Integer = 2                                    ' 更新開始フィールドINDEX
        Dim intCntUpd As Integer = 0                                ' 更新項目件数
        ' キー項目以後を繰り返す
        Do While intIx <= g_tblFld_MST_HAIZOKU.GetUpperBound(0)
            ' 変更がある項目のみSQLに追加
            If tblFldN(intIx) <> tblFldO(intIx) Then
                intCntUpd += 1
                ' 後続が" SET "でなければカンマを付加
                If Not strSQL.EndsWith(g_cnsSET) Then
                    strSQL &= g_cnsCOM
                End If
                ' 値が変更されたフィールドのみ更新
                strSQL &= g_tblFld_MST_HAIZOKU(intIx) & g_cnsEQ
                ' データタイプ判定(今回は日付と文字列のみ)
                Select Case g_tblFldTyp_MST_HAIZOKU(intIx)
                    Case 5                                          ' 日付
                        strSQL &= FP_SQLDateSUB2(tblFldN(intIx))
                    Case Else                                       ' 文字列
                        strSQL &= g_cnsSC & tblFldN(intIx).ToString & g_cnsSC
                End Select
            End If
            ' 次のフィールドへ
            intIx += 1
        Loop
        ' 更新項目があったか
        If intCntUpd <> 0 Then
            ' WHERE句を接続
            strUpdSQL = strSQL & strWhere
        End If
    End Sub

    '***********************************************************************************************
    '* 処理名　：FP_SetTableFromItems
    '* 機能　　：フォーム上のアイテムから更新用テーブルを作成(配属マスタ)
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：テーブル(Array:Object)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_SetTableFromItems() As Object()
        '-------------------------------------------------------------------------------------------
        Dim tblFldN() As Object                                         ' 新規登録側テーブル
        ReDim tblFldN(g_tblFld_MST_HAIZOKU.GetUpperBound(0))
        ' 社員コード以降のフィールドをセット
        tblFldN(0) = g_strScd                                           ' (00)社員コード
        tblFldN(1) = Date.Parse(LBL_KAISHI_YMD.Text)                    ' (01)開始日
        tblFldN(2) = g_cnsNullDate                                      ' (02)終了日(NULL)
        tblFldN(3) = g_tblBusyoCd(CBO_BUSYO.SelectedIndex)              ' (03)部署コード
        tblFldN(4) = g_tblYakuCd(CBO_YAKU.SelectedIndex)                ' (04)役職コード
        Return tblFldN
    End Function

    '***********************************************************************************************
    ' ■■■ サブ処理(表示系) ■■■
    '***********************************************************************************************
    '* 処理名　：FP_ShowSyainInfo
    '* 機能　　：指定社員情報の表示
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理成否(Boolean)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_ShowSyainInfo() As Boolean
        '-------------------------------------------------------------------------------------------
        Dim dbTbl As DataTable = Nothing                        ' DataTable
        Dim strSQL As String = g_strSQL_Base                    ' SQL文
        strSQL &= " WHERE H.[SCD]='" & g_strScd & g_cnsSC
        strSQL &= " AND H.[KAISHI_YMD]=" & FP_SQLDateSUB2(g_dteKaishiYmd) & g_cnsCOL
        ' DataTable取得
        If Not g_objAboutMDB.GetDataTableOle(dbTbl, strSQL, g_cnsMST_HAIZOKU) Then Return False
        ' 各コントロールに値をセット
        LBL_SCD.Text = dbTbl.Rows(0)(0)                         ' 社員コード
        LBL_SNAME.Text = dbTbl.Rows(0)(1)                       ' 氏名
        ToolTip1.SetToolTip(LBL_SNAME, dbTbl.Rows(0)(8))        ' カナ氏名(ToolTip)
        LBL_NYUSYA_YMD.Text = FP_EditDate(dbTbl.Rows(0)(4))     ' 入社日
        LBL_TAISYOKU_YMD.Text = FP_EditDate(dbTbl.Rows(0)(5))   ' 退職日
        ' 退職日(及び見出し)は登録されている場合のみ表示(NULL時は非表示)
        Dim blnTaisyoku As Boolean = Not DBNull.Value.Equals(dbTbl.Rows(0)(5)) ' 退職判定
        LBL_TAISYOKU_YMD.Visible = blnTaisyoku
        LBL_TAISYOKU_YMD2.Visible = blnTaisyoku
        LBL_KAISHI_YMD.Text = FP_EditDate(dbTbl.Rows(0)(9))     ' 配属開始日
        ' コンボボックスの選択をコードテーブルで行なう
        Call GP_SetComboIndexByCode(CBO_BUSYO, dbTbl.Rows(0)(6), g_tblBusyoCd) ' 部署
        Call GP_SetComboIndexByCode(CBO_YAKU, dbTbl.Rows(0)(7), g_tblYakuCd) ' 役職
        Return True
    End Function

    '***********************************************************************************************
    '* 処理名　：FP_SetFormList
    '* 機能　　：コンボリスト等の初期セットアップ
    '-----------------------------------------------------------------------------------------------
    '* 返り値　：処理成否(Boolean)
    '* 引数　　：(なし)
    '-----------------------------------------------------------------------------------------------
    '* 作成日　：2017年01月22日
    '* 作成者　：井上　治
    '* 更新日　：2017年01月22日
    '* 更新者　：井上　治
    '* 機能説明：
    '* 注意事項：
    '***********************************************************************************************
    Private Function FP_SetFormList() As Boolean
        '-------------------------------------------------------------------------------------------
        ' 部署コンボリストの生成
        Dim dbTbl As DataTable = Nothing                        ' DataTable
        Dim strSQL As String = "SELECT [BUSYO_CD]"              ' (00)部署コード
        strSQL &= ",[BUSYO_NM]"                                 ' (01)部署名
        strSQL &= g_cnsFROM & g_cnsMST_BUSYO
        strSQL &= " ORDER BY [BUSYO_CD];"
        ' DataTable取得
        If Not g_objAboutMDB.GetDataTableOle(dbTbl, strSQL, g_cnsMST_BUSYO) Then Return False
        ' コンボボックスのリストセット
        Call GP_SetComboBoxList(CBO_BUSYO, dbTbl, g_tblBusyoCd)
        '-------------------------------------------------------------------------------------------
        ' 役職コンボリストの生成
        strSQL = "SELECT [YAKU_CD]"                             ' (00)役職コード
        strSQL &= ",[YAKU_NM]"                                  ' (01)役職名
        strSQL &= g_cnsFROM & g_cnsMST_YAKU
        strSQL &= " ORDER BY [YAKU_CD];"
        ' DataTable取得
        If Not g_objAboutMDB.GetDataTableOle(dbTbl, strSQL, g_cnsMST_YAKU) Then Return False
        ' コンボボックスのリストセット
        Call GP_SetComboBoxList(CBO_YAKU, dbTbl, g_tblYakuCd)
        dbTbl.Clear()
        dbTbl.Reset()
        Return True
    End Function

    '***********************************************************************************************
    '   プロパティ
    '***********************************************************************************************
    ' 社員コード(String)
    '-----------------------------------------------------------------------------------------------
    Friend WriteOnly Property prpScd As String
        Set(value As String)
            g_strScd = value
        End Set
    End Property

    '===============================================================================================
    ' 配属開始日(Date)
    '-----------------------------------------------------------------------------------------------
    Friend WriteOnly Property prpKaishiYmd As Date
        Set(value As Date)
            g_dteKaishiYmd = value
        End Set
    End Property

    '===============================================================================================
    ' 更新結果(0=無,1=追加,2=更新,9=削除)(integer)
    '-----------------------------------------------------------------------------------------------
    Friend ReadOnly Property prpUpdateResult As Integer
        Get
            Return g_intUpdateResult
        End Get
    End Property

    '----------------------------------------<< End of Source >>------------------------------------
End Class